import { AgentEnvironment, IAgentUpdate, IStateUpdate } from 'enviro-rx';
import { IArtificialAState, IArtificialEState, IArtificialOptions, IGenomeOptions } from '../index';
export declare abstract class ArtificialSelection<Gen extends IGenomeOptions, Pheno> extends AgentEnvironment<IArtificialAState, IArtificialEState<Gen, Pheno>> {
    options: IArtificialOptions;
    constructor(options: IArtificialOptions);
    interact(interaction: IAgentUpdate<IArtificialAState>): Promise<IStateUpdate<IArtificialEState<Gen, Pheno>>>;
    readonly defaultState: IArtificialEState<Gen, Pheno>;
    private fillSpecimens(specs?, n?);
    private fillParents(parents?, n?);
    private createSpecimen();
    private reproduceSpecimen(parents);
    private reproduceSpecimens(specs, parents, n?);
}
