import { BehaviorSubject, Observable, Observer, Subject, Subscription } from 'rxjs';
import { IScheduler } from 'rxjs/Scheduler';
export declare class ReactiveProperty<T> {
    private _value;
    private subject;
    constructor(value?: T);
    value: T;
    subscribe(observer: (value: T) => void | Observer<T>): Subscription;
    filter(selector: (value: T) => boolean): Observable<T>;
    map<U>(selector: (value: T) => U): Observable<U>;
    throttleTime(dueTime: number, scheduler?: IScheduler): Observable<T>;
    throttle<TTimeout>(selector: (value: T) => Observable<TTimeout>): Observable<T>;
    bufferTime(timeSpan: number, scheduler?: IScheduler): Observable<T[]>;
    bufferCount(count: number, skip?: number): Observable<T[]>;
    bufferTimeCount(timeSpan: number, count: number, skip?: number, scheduler?: IScheduler): Observable<T[]>;
    zip<U>(other: Observable<U>): Observable<[T, U]>;
    asObservable(): Observable<T>;
    asObserver(): Observer<T>;
    asSubject(): Subject<T>;
    asBehaviourSubject(): BehaviorSubject<T>;
}
